/* eslint-disable react/prop-types */

import React, { useState } from 'react'

import Autocomplete from '@material-ui/lab/Autocomplete'
import TextField from '@material-ui/core/TextField'



export default function MCF_Autocomplete (props) {
  const [params, setParams] = useState(props.params)

  const handleChange = (event, newValue) => {
    setParams({...params, value: newValue})

    if (params.onChangeListener) {
      params.onChangeListener(newValue)
    }
  }

  return (
    <Autocomplete
      id={params.id}  // string
      value={params.value}  // an option from params.options
      style={{width: params.width}}  // number
      options={params.options}  // options to select
      defaultValue={params.defaultValue}  // an option from params.options
      getOptionLabel={option => option.key}
      onChange={handleChange}
      renderInput={parameters => <TextField
        {...parameters}
        label={params.label}  // string
        variant={params.variant}  // 'filled' | 'outlined' | 'standard'
        margin={params.margin} // 'dense' | 'none' | 'normal'
      />}
    />
  )
}
