/* eslint-disable react/prop-types */

import React, {useState} from 'react'

import FormControl from '@material-ui/core/FormControl'
import FormGroup from '@material-ui/core/FormGroup'
import FormHelperText from '@material-ui/core/FormHelperText'
import FormLabel from '@material-ui/core/FormLabel'

import ComponentFactory from '../ComponentFactory'
import {useStyles} from '../index'



export default function MCF_CheckboxesGroup (props) {
  const [params, setParams] = useState(props.params)
  const classes = useStyles()
  params.checkboxesState = {}
  params.checkboxes.map(checkbox => {
    params.checkboxesState[checkbox.id] = checkbox.isChecked
  })

  const handleChange = (checkboxID, checkboxValue) => {
    params.onChangeListener(checkboxID, checkboxValue)
    params.checkboxesState[checkboxID] = checkboxValue
    setParams(params)
  }

  const createCheckboxes = () => {
    return (
      params.checkboxes.map(checkbox => {
        const checkboxConfig = {
          type: 'checkbox',
          params: {
            id: checkbox.id,  // string
            checked: checkbox.checked,  // boolean
            label: checkbox.label,  // string
            onChangeListener: handleChange,
          },
        }

        return ComponentFactory.createComponent(checkboxConfig)
      })
    )
  }

  return (
    <FormControl component="fieldset" className={classes.formControl}>
      <FormLabel component="legend">{params.label}</FormLabel>
      <FormHelperText>{params.helperText/* string */}</FormHelperText>
      <FormGroup
        id={params.id}  // string
        row={params.isRow}  // boolean
      >
        {createCheckboxes()}
      </FormGroup>
    </FormControl>
  )
}
