/* eslint-disable react/prop-types */

import React, {useState} from 'react'

import TextField from '@material-ui/core/TextField'

import {useStyles} from '../index'



export default function MCF_Text (props) {
  const [params, setParams] = useState(props.params)
  const classes = useStyles()
  
  const handleChange = event => {
    const setError = isError => {
      setParams({...params, value: event.target.value, error: isError})
    }

    setParams({...params, value: event.target.value})

    if (params.onChangeListener){
      params.onChangeListener(event.target.value, setError)
    }
  }


  return (
    <form className={classes.container} noValidate autoComplete="off">
      <TextField
        id={params.id}  // string
        label={params.label}  // string
        className={classes.textField}
        value={params.value}
        onChange={handleChange}
        margin={params.margin} // 'dense' | 'none' | 'normal'
        required={params.required}  // boolean
        error={params.error}  // boolean
        disabled={params.disabled}  // boolean
        placeholder={params.placeholder}  // string
        helperText={params.helperText}  // string
        fullWidth={params.fullWidth}  // boolean
        variant={params.variant} // 'filled' | 'outlined' | 'standard'
        type={params.type} // HTML input type
        InputLabelProps={{
          shrink: params.shrink,  // boolean
        }}
      />
    </form>
  )
}
